-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function Attack07:StartActivity()
	print("START! -- Attack07:StartActivity()!");

	---------------------------------------------------------------------
	-- Mission framework generic part. Must present in every mission!
	-- self.ConfigName = "Defence01.dat";
	self.ConfigName = "current.dat";
	self.ModuleName = "UnmappedLands.rte";

	dofile("./"..self.ModuleName.."/Libraries/CF_ConfigLibrary.lua");
	dofile("./"..self.ModuleName.."/Libraries/CF_MissionLibrary.lua");
	
	self.Area = SceneMan.Scene:GetArea("Attack07");

	CF_InitFactions();
	self.Config = self:CreateFakeConfig();
	CF_InitMission(self.Config);
	-- end of generic part	
	---------------------------------------------------------------------

	self.EnemyLZ = {}
	self.EnemyLZ[1] = SceneMan.Scene:GetArea("EnemyLZ1");
	self.EnemyLZ[2] = SceneMan.Scene:GetArea("EnemyLZ2");

	self.DistributionPoints = {}
	self.DistributionPoints[1] = SceneMan.Scene:GetArea("DistributionPoint1");
	self.DistributionPoints[2] = SceneMan.Scene:GetArea("DistributionPoint2");
	
	self.BasePosts = {};
	self.BasePosts[1] = SceneMan.Scene:GetArea("BasePost1");
	self.BasePosts[2] = SceneMan.Scene:GetArea("BasePost2");
	self.BasePosts[3] = SceneMan.Scene:GetArea("BasePost3");

	self.BasePostsUnitsSent = {};
	for i = 1 , 3 do
		self.BasePostsUnitsSent[i] = -100000;
	end
	
	self.IsBasePostEmpty = {};
	for i = 1 , 3 do
		self.IsBasePostEmpty[i] = true;
	end

	-- How much time to wait until trooper reach his assigned position
	self.DeploymentDelay = 20000
	
	self.BrainChambers = {}
	self.BrainChambers[1] = SceneMan.Scene:GetArea("BrainChamberA");
	self.BrainChambers[2] = SceneMan.Scene:GetArea("BrainChamberB");

	self.IsBrainChamberEmpty = {}
	self.IsBrainChamberEmpty[1] = true;
	self.IsBrainChamberEmpty[2] = true;
	
	self.BrainInChamber = 1;
	
	self.BrainDests = {}
	self.BrainDests[1] = SceneMan.Scene:GetArea("BrainDestA");
	self.BrainDests[2] = SceneMan.Scene:GetArea("BrainDestB");

	self.ProxyWaypoint = SceneMan.Scene:GetArea("ProxyWaypoint");
	
	self.BrainTeleportDelay = 10000;
	self.LastBrainTeleportTime = 0;
	
	self.braindead = {};
	self.AssignedBrains = {};
	
	for player = 0, self.PlayerCount - 1 do
        if not self:GetPlayerBrain(player) then
			self.braindead[player] = false;
			local brain = CF_SpawnBrain(CF_PlayerTeam , nil , CF_PlayerFaction , Actor.AIMODE_SENTRY);
			-- brain.Pos = Vector(2092 , 564); -- Debug
			-- brain:AddInventoryItem(CreateHDFirearm("Heavy Digger" , "Base.rte")); -- Debug
			brain.Pos = Vector(170 + player * 30 , 1820); -- Gameplay
			brain.AIMode = Actor.AIMODE_SENTRY;
			self.AssignedBrains[player] = brain;

            MovableMan:AddActor(brain);
            self:SetPlayerBrain(brain, player);
            SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
            self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
			self:SwitchToActor(brain, player, CF_PlayerTeam);
        end
    end

	---------------------------------------------------------------------
	-- Mission framework generic part. Must present in every mission!
	CF_ReplaceAddedActors(self.Config);
	CF_ArrangeEliteActors(self.Config);
	-- end of generic part	
	---------------------------------------------------------------------
	
    self.FightPhase = { NOFIGHT = 0};
    self.CurrentFightPhase = self.FightPhase.NOFIGHT;
	
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	self.TeleportTimer = Timer();
	self.TeleportTimer:Reset();

	self.TeleportBlinkTimer = Timer();
	self.TeleportBlinkTimer:Reset();
	
	self.DropshipSpawnInterval = 24000; --16000;
	self.DropshipSpawnTimer = Timer();
	self.DropshipSpawnTimer:Reset();
	
	for actor in MovableMan.AddedActors do
		actor.AIMode = Actor.AIMODE_SENTRY;
	end	

	-- Debug
	--[[self.Screen = CreateAEmitter("Att01 Download Screen");
	self.Screen.Pos = Vector(192 , 264);
	self.Screen:EnableEmission(true);
	MovableMan:AddParticle(self.Screen); --]]--
	
	
	--[[for actor in MovableMan.AddedActors do
		if actor.Team == CF_CPUTeam then
			actor:GibThis();
		end
	end
	
	--]]--
end
-----------------------------------------------------------------------------------------
-- Create fake config to simulate campaign framework
-----------------------------------------------------------------------------------------
function Attack07:CreateFakeConfig()
	local config = {};
	
	config["PlayerFaction"] = CF_Factions[math.random(#CF_Factions)];
	config["LastMissionCPUFaction"] = CF_Factions[math.random(#CF_Factions)];

	config["PlayerGold"] = 12000;
	config["LastMissionAIBudget"] = 6000;

	config["MaxElite"] = 2;
	config["Elite1"] = CF_ActorSets[config["PlayerFaction"]][math.random(#CF_ActorSets[config["PlayerFaction"]])];
	config["Elite2"] = CF_ActorSets[config["PlayerFaction"]][math.random(#CF_ActorSets[config["PlayerFaction"]])];

	config["TurnNumber"] = 1;
	
	return config;
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
function Attack07:PauseActivity(pause)
    print("PAUSE! -- Attack07:PauseActivity()!");
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
function Attack07:EndActivity()
    print("END! -- Attack07:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Attack07:DistributeReinforcements()
	-- Assign falling troops to specific firing points
	for actor in MovableMan.Actors do
		if actor.Team == CF_CPUTeam and actor.AIMode == Actor.AIMODE_SENTRY then
			if self.DistributionPoints[1]:IsInside(actor.Pos) then
				local isassigned;
				isassigned = false;
				for i = 1 , 2 do
					if self.IsBasePostEmpty[i] and self.GenericTimer.ElapsedSimTimeMS - self.BasePostsUnitsSent[i] > self.DeploymentDelay then
						actor.AIMode = Actor.AIMODE_GOTO;
						actor:ClearAIWaypoints();
						actor:AddAISceneWaypoint(self.BasePosts[i]:GetCenterPoint());
						
						isassigned = true;
						self.BasePostsUnitsSent[i] = self.GenericTimer.ElapsedSimTimeMS;
						print("Assigned to ")
						print(i)
						break;
					end -- if
				end -- for i
				
				-- If all points in selected zone are taken, assign to brain hunt
				-- to avoid crowds of sentry troops
				if not isassigned then
					print ("Hunter!")
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
				end

			elseif self.DistributionPoints[2]:IsInside(actor.Pos) then
				local isassigned;
				isassigned = false;
				for i = 2 , 3 do
					if self.IsBasePostEmpty[i] and self.GenericTimer.ElapsedSimTimeMS - self.BasePostsUnitsSent[i] > self.DeploymentDelay then
						actor.AIMode = Actor.AIMODE_GOTO;
						actor:ClearAIWaypoints();
						
						-- 3rd post is too distant so we send troops via another waypoint
						if i == 3 then
							actor:AddAISceneWaypoint(self.ProxyWaypoint:GetCenterPoint());
						else
							actor:AddAISceneWaypoint(self.BasePosts[i]:GetCenterPoint());
						end
						
						isassigned = true;
						self.BasePostsUnitsSent[i] = self.GenericTimer.ElapsedSimTimeMS;
						print("Assigned to ")
						print(i)
						break;
					end -- if
				end -- for i
				
				-- If all points in selected zone are taken, assign to brain hunt
				-- to avoid crowds of sentry troops
				if not isassigned then
					print ("Hunter!")
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
				end

			elseif 	self.ProxyWaypoint:IsInside(actor.Pos) then
				actor:AddAISceneWaypoint(self.BasePosts[3]:GetCenterPoint());
			end -- if 
		end -- if
	end
end
-----------------------------------------------------------------------------------------
-- Update base defence stats to make dispatch decisions later
-----------------------------------------------------------------------------------------
function Attack07:UpdateUnitStats()
	-- Reset all current states, they are refilled here
	-- Zones are considered non-empty if we have non-expired troops sent to this zone
	for i = 1 , #self.IsBasePostEmpty do
		self.IsBasePostEmpty[i] = true;
	end

	for chmbr = 1 , #self.IsBrainChamberEmpty do
		self.IsBrainChamberEmpty[chmbr] = true;
	end
	
	local aihascommander = false;
	
	for actor in MovableMan.Actors do
		-- Check for empty firing points
		if actor.Team == CF_CPUTeam  then
			for i = 1 , #self.BasePosts do
				if self.BasePosts[i]:IsInside(actor.Pos) then
					self.IsBasePostEmpty[i] = false;
				end -- if
			end -- for
			
			if string.find(actor.PresetName ,"Brain") then
				aihascommander = true;
				self:AddObjectivePoint("Kill", actor.AboveHUDPos, CF_PlayerTeam, GameActivity.ARROWDOWN);
				
				self.BrainInChamber = 0;
				
				for chmbr = 1 , #self.BrainChambers do
					if self.BrainChambers[chmbr]:IsInside(actor.Pos) then
						self.BrainInChamber = chmbr;
					end
				end
			end
		end -- if
		
		if actor.Team == CF_PlayerTeam  then
			for chmbr = 1 , #self.IsBrainChamberEmpty do
				if self.BrainChambers[chmbr]:IsInside(actor.Pos) then
					self.IsBrainChamberEmpty[chmbr] = false;
				end -- if
			end
		end
	end
	
	if self.GenericTimer:IsPastSimMS(500) then
		-- AI commander died, victory
		if not aihascommander then
			if CF_Activity.ActivityState ~= Activity.OVER then
				---------------------------------------------------------------------
				-- Mission framework generic part. Must present in every mission!
				CF_CommitVictory(self.Config , self.ModuleName , self.ConfigName);
				-- end of generic part
				---------------------------------------------------------------------
				self.WinnerTeam = CF_PlayerTeam;
				ActivityMan:EndActivity();
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Spawn dropship. Returns true if spawn is successfull, false otherwise
-----------------------------------------------------------------------------------------
function Attack07:ControlBrainTeleport()
	if (self.BrainInChamber > 0 and self.BrainInChamber < 3) then
		if (self.IsBrainChamberEmpty[self.BrainInChamber] == false) then
			for actor in MovableMan.Actors do
				if actor.Team == CF_CPUTeam  then
					if string.find(actor.PresetName ,"Brain") then
						if self.TeleportTimer:IsPastSimMS(self.BrainTeleportDelay) then
							actor:FlashWhite(1000);
							local fxa = CreateAEmitter("Teleporter Effect A");
							fxa.Pos = actor.Pos;
							MovableMan:AddParticle(fxa);
							
							if self.BrainInChamber == 1 then
								actor.Pos = self.BrainDests[2]:GetCenterPoint()
							else
								actor.Pos = self.BrainDests[1]:GetCenterPoint()
							end
							self.TeleportTimer:Reset();
							self.DropshipSpawnInterval = 12000;
						else
							local blinkdelay = 0
							
							if self.TeleportTimer.ElapsedSimTimeMS  > (self.BrainTeleportDelay / 4) * 3 then
								blinkdelay = 200;
							elseif self.TeleportTimer.ElapsedSimTimeMS  > (self.BrainTeleportDelay / 4) * 2 then
								blinkdelay = 400
							else
								blinkdelay = 600;
							end
						
							if self.TeleportBlinkTimer:IsPastSimMS(blinkdelay) then
								actor:FlashWhite(100);
								self.TeleportBlinkTimer:Reset();
							end
						end
					end
				end
			end
		else
			self.TeleportTimer:Reset();
		end
	end
end
-----------------------------------------------------------------------------------------
-- Spawn dropship. Returns true if spawn is successfull, false otherwise
-----------------------------------------------------------------------------------------
function Attack07:SpawnDropship()
	if self.DropshipSpawnTimer:IsPastSimMS(self.DropshipSpawnInterval) then
		if MovableMan:GetMOIDCount() < CF_MOIDLimit - 20 then
			local ship = nil;
			local actor = nil;
			local price = 0;
			local totalprice = 0;
			local p;
			local landpos;
			local lznum;
			local spawnhunters = false;
		
			-- Select landing zone
			
			if self.IsBasePostEmpty[1] and self.GenericTimer.ElapsedSimTimeMS - self.BasePostsUnitsSent[1] > self.DeploymentDelay then
				lznum = 1;
			elseif self.IsBasePostEmpty[2] and self.GenericTimer.ElapsedSimTimeMS - self.BasePostsUnitsSent[2] > self.DeploymentDelay then
				if math.random() < 0.5 then
					lznum = 1;
				else
					lznum = 2;
				end
			elseif self.IsBasePostEmpty[3] and self.GenericTimer.ElapsedSimTimeMS - self.BasePostsUnitsSent[3] > self.DeploymentDelay then
				lznum = 2;
			else
				lznum = 1;
			end
			
			landpos = Vector(self.EnemyLZ[lznum]:GetCenterPoint().X , -10);
			
			ship , price = CF_SpawnDropship(CF_CPUTeam , landpos , CF_CPUFaction);
			totalprice = totalprice + price;
			
			local aimode;
			
			aimode = Actor.AIMODE_SENTRY;
			
			if math.random() < 0.15 then
				print ("Hunter (dropship)!")
				aimode = Actor.AIMODE_BRAINHUNT;
				spawnhunters = true;
			end
		
			-- Spawn armor or regular troopers depending on turn number to increase difficulty
			if math.random() < 0.15 then
				-- Give single dreadnought as dummy armor or two assalut troopers with shields
				-- to any other faction
				if CF_CPUFaction == CF_Factions.DUMMY then
					actor , price = CF_SpawnArmor(CF_CPUTeam , nil , CF_CPUFaction , aimode);
					totalprice = totalprice + price;
					
					ship:AddInventoryItem(actor);
				else
					for i = 1, 2 do
						actor , price = CF_SpawnArmor(CF_CPUTeam , nil , CF_CPUFaction , aimode);
						if spawnhunters then
							-- actor:AddInventoryItem(CreateHDFirearm("Heavy Digger" , "Base.rte"));
						end
						totalprice = totalprice + price;

						ship:AddInventoryItem(actor);
					end
				end
			else
				for i = 1, 2 do
					actor , price = CF_SpawnRandomInfantry(CF_CPUTeam , nil , CF_CPUFaction , aimode);
					if spawnhunters then
						-- actor:AddInventoryItem(CreateHDFirearm("Heavy Digger" , "Base.rte"));
					end
					totalprice = totalprice + price;

					ship:AddInventoryItem(actor);
				end
			end

			MovableMan:AddActor(ship); --]]--
		end 
		self.DropshipSpawnTimer:Reset();
	end
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function Attack07:UpdateActivity()
   	self:ClearObjectivePoints();
	
	if not self.GenericTimer:IsPastSimMS(1500) then
		for player = 0, self.PlayerCount - 1 do
			self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
			FrameMan:SetScreenText("ELEMINATE ENEMY COMMANDER!", player, 500, 10000, true);
		end
	end

	if not self.GenericTimer:IsPastSimMS(5000) then
		for player = 0, self.PlayerCount - 1 do
			if MovableMan:IsActor(self.AssignedBrains[player]) then
				self:AddObjectivePoint("Protect Commander", self.AssignedBrains[player].AboveHUDPos, CF_PlayerTeam, GameActivity.ARROWDOWN);
			end
		end
	end
	
	self:UpdateUnitStats();
	self:ControlBrainTeleport();
	self:DistributeReinforcements();
	self:SpawnDropship();
	
	---------------------------------------------------------------------
	-- Mission framework generic part. Must present in every mission!
	CF_ReturnOnMissionEnd();
	CF_CheckForeignTroops();
	-- end of generic part
	---------------------------------------------------------------------
	
	self:DoBrainSelection();
	
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function Attack07:DoBrainSelection()
	if not (self.ActivityState == Activity.OVER) then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
	
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);
				else
					self.braindead[player] = true;
					
					--if not MovableMan:GetClosestBrainActor(team) then
						if CF_Activity.ActivityState ~= Activity.OVER then
							---------------------------------------------------------------------
							-- Mission framework generic part. Must present in every mission!
							CF_CommitDefeat(self.Config , self.ModuleName , self.ConfigName);
							-- end of generic part
							---------------------------------------------------------------------
							self.WinnerTeam = self:OtherTeam(team);
							ActivityMan:EndActivity();
						end
					--end
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end -- 
		end --for
	end --if
end
-----------------------------------------------------------------------------------------
-- Enter orbit, check winning conditions
-----------------------------------------------------------------------------------------
function Attack07:CraftEnteredOrbit()
	if self.OrbitedCraft:HasObject("Brain Robot") then
		if CF_Activity.ActivityState ~= Activity.OVER then
			---------------------------------------------------------------------
			-- Mission framework generic part. Must present in every mission!
			CF_CommitRetreat(self.Config , self.ModuleName , self.ConfigName);
			-- end of generic part
			---------------------------------------------------------------------
			self.WinnerTeam = CF_CPUTeam;
			ActivityMan:EndActivity();
		end
	end
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------



































